import type { SchemaConfig as SchemaConfiguration, GraphQLLanguageConfig } from 'graphql-language-service';
import type { languages } from 'monaco-editor';
import type { Options as PrettierConfig } from 'prettier';
export interface IDisposable {
    dispose(): void;
}
export declare type SchemaConfig = SchemaConfiguration;
export declare type JSONDiagnosticOptions = languages.json.DiagnosticsOptions;
export interface IEvent<T> {
    (listener: (e: T) => any, thisArg?: any): IDisposable;
}
export declare type FilePointer = string | string[];
export declare type FormattingOptions = {
    prettierConfig?: PrettierConfig;
};
export interface ModeConfiguration {
    readonly documentFormattingEdits?: boolean;
    readonly documentRangeFormattingEdits?: boolean;
    readonly completionItems?: boolean;
    readonly hovers?: boolean;
    readonly documentSymbols?: boolean;
    readonly tokens?: boolean;
    readonly colors?: boolean;
    readonly foldingRanges?: boolean;
    readonly diagnostics?: boolean;
    readonly selectionRanges?: boolean;
}
export declare type DiagnosticSettings = {
    validateVariablesJSON?: Record<string, string[]>;
    jsonDiagnosticSettings?: languages.json.DiagnosticsOptions;
};
export declare type MonacoGraphQLInitializeConfig = {
    schemas?: SchemaConfig[];
    diagnosticSettings?: DiagnosticSettings;
    formattingOptions?: FormattingOptions;
    modeConfiguration?: ModeConfiguration;
};
export interface ICreateData {
    languageId: string;
    formattingOptions?: FormattingOptions;
    languageConfig: GraphQLLanguageConfig;
    diagnosticSettings: DiagnosticSettings;
}
//# sourceMappingURL=index.d.ts.map